##====================================================================
##  成績表
##  score1.awk
##====================================================================

##--------------------------------------------------------------------
##  事前処理
##--------------------------------------------------------------------

BEGIN {
    ##----  成績情報
    score_all = "S A B C X";
    score_num = split(score_all, score_list);    # 添字は0からになる
    ##----  科目情報
    subj_all = "国語 数学 英語 理科 社会 音楽";
    subj_num = split(subj_all, subj_list);    # 添字は1からになる
}

##--------------------------------------------------------------------
##  本体処理
##--------------------------------------------------------------------

{
    stud[$1] = 1;           # 学生の出現
    stud_score[$1,$3]++;    # 学生ごとの成績の集計
    subj_score[$2,$3]++;    # 科目ごとの成績の集計
    score[$1,$2] = $3;      # 成績の格納
}

##--------------------------------------------------------------------
##  事後処理
##--------------------------------------------------------------------

END {
    ##--  学生ごとの成績分布
    print "学生ごとの成績分布";
    print "     : " score_all;
    for ( st in stud ) {
        printf st " : ";
        for ( k = 1; k <= score_num; k++ ) {
          sc = score_list[k];
          printf stud_score[st,sc]+0 " ";
        }
        print "";
    }
    print "";

    ##--  科目ごとの成績分布
    print "科目ごとの成績分布";
    print "     : " score_all;
    for ( s = 1; s <= subj_num; s++ ) {    # 添字の範囲に注意
        sb = subj_list[s];
        printf sb " : ";
        for ( k = 0; k < score_num; k++ ) {
            sc = score_list[k];
            printf subj_score[sb,sc]+0 " ";
        }
        print "";
    }

}
